
package org.soitoolkit.commons.studio.components.logger.processors;

import java.util.List;
import java.util.Map;
import javax.annotation.Generated;
import org.mule.api.MessagingException;
import org.mule.api.MuleContext;
import org.mule.api.MuleEvent;
import org.mule.api.MuleException;
import org.mule.api.construct.FlowConstruct;
import org.mule.api.lifecycle.Disposable;
import org.mule.api.lifecycle.Initialisable;
import org.mule.api.lifecycle.InitialisationException;
import org.mule.api.lifecycle.Startable;
import org.mule.api.lifecycle.Stoppable;
import org.mule.api.process.ProcessAdapter;
import org.mule.api.process.ProcessCallback;
import org.mule.api.process.ProcessTemplate;
import org.mule.api.processor.MessageProcessor;
import org.mule.config.i18n.CoreMessages;
import org.soitoolkit.commons.studio.components.logger.LoggerModule;
import org.soitoolkit.commons.studio.components.logger.adapters.LoggerModuleProcessAdapter;


/**
 * LogInfoMessageProcessor invokes the {@link org.soitoolkit.commons.studio.components.logger.LoggerModule#logInfo(java.lang.String, java.lang.String, java.lang.String, java.lang.String, java.lang.String, java.util.Map)} method in {@link LoggerModule }. For each argument there is a field in this processor to match it.  Before invoking the actual method the processor will evaluate and transform where possible to the expected argument type.
 * 
 */
@Generated(value = "Mule DevKit Version 3.3.1", date = "2013-01-15T10:12:12+01:00", comments = "Build 3.3.1.1298.3ae82a7")
public class LogInfoMessageProcessor
    extends AbstractMessageProcessor<Object>
    implements Disposable, Initialisable, Startable, Stoppable, MessageProcessor
{

    protected Object message;
    protected String _messageType;
    protected Object integrationScenario;
    protected String _integrationScenarioType;
    protected Object messageType;
    protected String _messageTypeType;
    protected Object contractId;
    protected String _contractIdType;
    protected Object correlationId;
    protected String _correlationIdType;
    protected Object extraInfo;
    protected Map<String, String> _extraInfoType;

    /**
     * Obtains the expression manager from the Mule context and initialises the connector. If a target object  has not been set already it will search the Mule registry for a default one.
     * 
     * @throws InitialisationException
     */
    public void initialise()
        throws InitialisationException
    {
    }

    public void start()
        throws MuleException
    {
    }

    public void stop()
        throws MuleException
    {
    }

    public void dispose() {
    }

    /**
     * Set the Mule context
     * 
     * @param context Mule context to set
     */
    public void setMuleContext(MuleContext context) {
        super.setMuleContext(context);
    }

    /**
     * Sets flow construct
     * 
     * @param flowConstruct Flow construct to set
     */
    public void setFlowConstruct(FlowConstruct flowConstruct) {
        super.setFlowConstruct(flowConstruct);
    }

    /**
     * Sets message
     * 
     * @param value Value to set
     */
    public void setMessage(Object value) {
        this.message = value;
    }

    /**
     * Sets correlationId
     * 
     * @param value Value to set
     */
    public void setCorrelationId(Object value) {
        this.correlationId = value;
    }

    /**
     * Sets extraInfo
     * 
     * @param value Value to set
     */
    public void setExtraInfo(Object value) {
        this.extraInfo = value;
    }

    /**
     * Sets contractId
     * 
     * @param value Value to set
     */
    public void setContractId(Object value) {
        this.contractId = value;
    }

    /**
     * Sets messageType
     * 
     * @param value Value to set
     */
    public void setMessageType(Object value) {
        this.messageType = value;
    }

    /**
     * Sets integrationScenario
     * 
     * @param value Value to set
     */
    public void setIntegrationScenario(Object value) {
        this.integrationScenario = value;
    }

    /**
     * Invokes the MessageProcessor.
     * 
     * @param event MuleEvent to be processed
     * @throws MuleException
     */
    public MuleEvent process(final MuleEvent event)
        throws MuleException
    {
        try {
            findOrCreate(LoggerModuleProcessAdapter.class, true, event);
            final String _transformedMessage = ((String) evaluateAndTransform(getMuleContext(), event, LogInfoMessageProcessor.class.getDeclaredField("_messageType").getGenericType(), null, message));
            final String _transformedIntegrationScenario = ((String) evaluateAndTransform(getMuleContext(), event, LogInfoMessageProcessor.class.getDeclaredField("_integrationScenarioType").getGenericType(), null, integrationScenario));
            final String _transformedMessageType = ((String) evaluateAndTransform(getMuleContext(), event, LogInfoMessageProcessor.class.getDeclaredField("_messageTypeType").getGenericType(), null, messageType));
            final String _transformedContractId = ((String) evaluateAndTransform(getMuleContext(), event, LogInfoMessageProcessor.class.getDeclaredField("_contractIdType").getGenericType(), null, contractId));
            final String _transformedCorrelationId = ((String) evaluateAndTransform(getMuleContext(), event, LogInfoMessageProcessor.class.getDeclaredField("_correlationIdType").getGenericType(), null, correlationId));
            final Map<String, String> _transformedExtraInfo = ((Map<String, String> ) evaluateAndTransform(getMuleContext(), event, LogInfoMessageProcessor.class.getDeclaredField("_extraInfoType").getGenericType(), null, extraInfo));
            Object resultPayload;
            ProcessTemplate<Object, Object> processTemplate = ((ProcessAdapter<Object> ) getModuleObject()).getProcessTemplate();
            resultPayload = processTemplate.execute(new ProcessCallback<Object,Object>() {


                public List<Class> getManagedExceptions() {
                    return null;
                }

                public boolean isProtected() {
                    return false;
                }

                public Object process(Object object)
                    throws Exception
                {
                    return ((LoggerModule) object).logInfo(_transformedMessage, _transformedIntegrationScenario, _transformedMessageType, _transformedContractId, _transformedCorrelationId, _transformedExtraInfo);
                }

            }
            , this, event);
            overwritePayload(event, resultPayload);
            return event;
        } catch (MessagingException messagingException) {
            messagingException.setProcessedEvent(event);
            throw messagingException;
        } catch (Exception e) {
            throw new MessagingException(CoreMessages.failedToInvoke("logInfo"), event, e);
        }
    }

}
